/**
 * Created by User on 11/9/14.
 */
var stringArray = ['Blue', 'Humpback', 'Beluga'];

console.log('stringArray:', stringArray.join());
console.log('Sorted:', stringArray.sort());

var numberArray = [40, 1, 5, 200];

function compareNumbers(a, b) {
    return a - b;
}

console.log('numberArray:', numberArray.join());
console.log('Sorted without a compare function:', numberArray.sort());
console.log('Sorted with compareNumbers:', numberArray.sort(compareNumbers));

var numericStringArray = ['80', '9', '700'];

console.log('numericStringArray:', numericStringArray.join());
console.log('Sorted without a compare function:', numericStringArray.sort());
console.log('Sorted with compareNumbers:', numericStringArray.sort(compareNumbers));

var mixedNumericArray = ['80', '9', '700', 40, 1, 5, 200];

console.log('mixedNumericArray:', mixedNumericArray.join());
console.log('Sorted without a compare function:', mixedNumericArray.sort());
console.log('Sorted with compareNumbers:', mixedNumericArray.sort(compareNumbers));


var items = ['réservé', 'premier', 'cliché', 'communiqué', 'café', 'adieu'];
items.sort(function (a, b) {
    return a.localeCompare(b);
});

// the array to be sorted
var list = ['Delta', 'alpha', 'CHARLIE', 'bravo'];

// temporary holder of position and sort-value
var map = list.map(function(e, i) {
    return { index: i, value: e.toLowerCase() };
})

// sorting the map containing the reduced values
map.sort(function(a, b) {
    return +(a.value > b.value) || +(a.value === b.value) - 1;
});

// container for the resulting order
var result = map.map(function(e){
    return list[e.index];
});

var myArray = ['one', 'two', 'three'];
myArray.reverse();

console.log(myArray) // ['three', 'two', 'one']